package com.jiuqi.util.biff;

import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.util.Date;

public class BIFFWriter extends BIFFFiler {
   public BIFFWriter() {
   }

   public BIFFWriter(Stream stream) {
      super(stream);
   }

   public void write() throws StreamException {
      this.stream.write(this.biff.getSign());
      this.stream.writeInt(this.biff.getSize());
      this.stream.copyFrom(this.biff.getData(), 0L);
   }

   public void write(byte sign) throws StreamException {
      this.biff.reset(sign);
      this.write();
   }

   public void write(byte sign, int value) throws StreamException {
      this.biff.reset(sign);
      this.biff.getData().writeInt(value);
      this.write();
   }

   public void write(byte sign, double value) throws StreamException {
      this.biff.reset(sign);
      this.biff.getData().writeDouble(value);
      this.write();
   }

   public void write(byte sign, String value) throws StreamException {
      this.biff.reset(sign);
      if (value != null) {
         this.biff.getData().writeString(value);
      }

      this.write();
   }

   public void write(byte sign, boolean value) throws StreamException {
      this.biff.reset(sign);
      this.biff.getData().writeBool(value);
      this.write();
   }

   public void write(byte sign, long value) throws StreamException {
      this.biff.reset(sign);
      this.biff.getData().writeLong(value);
      this.write();
   }

   public void write(byte sign, Date value) throws StreamException {
      this.biff.reset(sign);
      this.biff.getData().writeLong(value.getTime());
      this.write();
   }

   public void write(byte sign, byte[] value) throws StreamException {
      this.biff.reset(sign);
      this.biff.getData().writeBuffer(value, 0, value.length);
      this.write();
   }

   public void writeEOF() throws StreamException {
      this.write(this.eofSign);
   }
}
